package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.UserRole;
import com.sa.ibiz.demo.demo.service.UserRoleService;
import com.sa.ibiz.demo.demo.service.dto.UserRoleSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/userrole")
public class UserRoleResource
{
	@Autowired
	private UserRoleService service;


	@PostMapping(value = "/checkKey")
	public ResponseEntity<UserRole> checkKey(@Validated @RequestBody UserRole data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("用户角色[checkKey]操作发生错误","UserRole",data.getUserroleid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<UserRole> update(@Validated @RequestBody UserRole data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("用户角色[update]操作发生错误","UserRole",data.getUserroleid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<UserRole> getDraft(@Validated @RequestBody UserRole data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("用户角色[getDraft]操作发生错误","UserRole","");
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<UserRole> get(@Validated @PathVariable String id){
		UserRole data=new UserRole();
		data.setUserroleid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("用户角色[get]操作发生错误","UserRole",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<UserRole> remove(@Validated @RequestBody UserRole data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("用户角色[remove]操作发生错误","UserRole",data.getUserroleid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<UserRole> create(@Validated @RequestBody UserRole data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("用户角色[create]操作发生错误","UserRole",data.getUserroleid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<UserRole>> searchDefaultPage(@Validated @RequestBody UserRoleSearchFilter filter){
		Page<UserRole> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<UserRole>> listDefault(@Validated @RequestBody UserRoleSearchFilter filter){
		List<UserRole> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
